//
// dl.cpp: routines for dynamicc linking (It is, in fact, a C program)
//

#include "dl.h"

DLHANDLE DL_OpenLibrary(char *libname)
{
#ifdef WIN32
	return LoadLibrary(libname);
#else
	return dlopen(libname, RTLD_LAZY);
#endif
}

bool DL_CloseLibrary(DLHANDLE dlhandle)
{
#ifdef WIN32
	if (FreeLibrary(dlhandle)) 
		return true;
	else 
		return false;
#else
	if (dlclose(dlhandle)) 
		return true;
	else 
		return false;
#endif
}

void *DL_BindFunction(DLHANDLE dlhandle, char *symbol)
{
#ifdef WIN32
	return GetProcAddress(dlhandle, symbol);
#else
	return dlsym(dlhandle, symbol);
#endif
}